package dpexamples.day2;

import java.io.File;
import java.util.List;
import java.util.ArrayList;

abstract class AbstractFile {
	
	String name;
	long size;
	AbstractFile parent;
    List<AbstractFile> contains = new ArrayList<AbstractFile>();
	
	long getSize() {
		return size;
	}
	
	AbstractFile(String name) {
		this.name = name;
	}
	
    void add(AbstractFile af) {
    	contains.add(af);
    	af.parent = this;
    }
    void accept(FileVisitor v) {
    	if (this instanceof RegularFile)
    	v.visit((RegularFile) this);
    	if (this instanceof Directory)
        	v.visit((Directory) this);
    	// else do nothing
    }
}
