package dpexamples.day3;

import java.util.ArrayList;
import java.util.List;

public class House {
	
	
	List<AlarmDevice> alarms = new ArrayList<AlarmDevice>();
	
	public void alarm() {
		for (AlarmDevice a : alarms) {
			a.alarm();
		}
	}
	
	public static void main(String[] args) {
		House house = new House();
		house.init();
		house.alarm();
	}

	private void init() {
		FlashLight a1 = new FlashLight();
		alarms.add(a1);
		Siren a2 = new Siren();
		alarms.add(a2);
		MailNotification a3 = new MailNotification();
		alarms.add(a3);
	}
}

abstract class AlarmDevice {
	void alarm() {}
}

class Siren extends AlarmDevice {

	void alarm() {
		System.out.println("Siren on!");
	}
	
}

class FlashLight extends AlarmDevice {

	void alarm() {
		System.out.println("Flashlight on!");
	}
	
}

class MailNotification extends AlarmDevice {

	void alarm() {
		System.out.println("Sent an email to my blackberry!");
	}
	
}